import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.KeyGenerator;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;


public class CipherDemo {
	
	private Cipher cipher;
	private SecretKey secretKey;
	
	public CipherDemo (String algorithm) throws NoSuchAlgorithmException, NoSuchPaddingException {
		this.cipher = Cipher.getInstance(algorithm);
		this.secretKey = generateKey();
		
	}
	
	private byte[] encrypt(byte[] msg) throws 
	InvalidKeyException, IllegalBlockSizeException, BadPaddingException {
		cipher.init(Cipher.ENCRYPT_MODE, secretKey);
		return cipher.doFinal(msg);
	}
	
	private byte[] decrypt(byte[] msg) throws 
	InvalidKeyException, IllegalBlockSizeException, BadPaddingException {
		cipher.init(Cipher.DECRYPT_MODE, secretKey);
		return cipher.doFinal(msg);
	}
	
	public static void main(String[] args) {
		try {
			CipherDemo cd = new CipherDemo("DESede");
			byte[] plaintext = ("Please transfer $2 000 000 " +
					"from the NOKAS heist to account: " +
					"3624.19.39845").getBytes();
			
			System.out.println("PLAINTEXT: ");
			
			cd.printByteArray(plaintext);
			
			byte[] ciphertext = cd.encrypt(plaintext);
			
			System.out.println("CIPHERTEXT: ");
			
			cd.printByteArray(ciphertext);
			
			byte[] decryptedText = cd.decrypt(ciphertext);
			
			System.out.println("New PLAINTEXT: ");
			
			cd.printByteArray(decryptedText);
		} catch (InvalidKeyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (BadPaddingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private SecretKey generateKey () throws NoSuchAlgorithmException {
		KeyGenerator kg = KeyGenerator.getInstance("DESede");
		return kg.generateKey();
	}
	
	private void printByteArray (byte[] b) {
		for(int i=0; i < b.length; i++) {
			System.out.print((char)b[i]);
		}
		System.out.println("\n");
	}
}
