import java.security.InvalidKeyException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Signature;
import java.security.SignatureException;

public class PublicKeyCrypto {

	private PrivateKey privKey;
	private PublicKey pubKey;
	private String proposal;
	
	public PublicKeyCrypto () {
		try {
			KeyPair kp = generateKeyPair();
			privKey = kp.getPrivate();
			pubKey = kp.getPublic();
			proposal = "Will you marry me?";
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main (String[] args) {
		PublicKeyCrypto pkc = new PublicKeyCrypto();
		
		try {
			byte[] signature = pkc.sign(pkc.proposal.getBytes());
			
			System.out.println(pkc.verify(pkc.proposal.getBytes(), signature) );
		} catch (InvalidKeyException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (SignatureException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private KeyPair generateKeyPair () throws NoSuchAlgorithmException {
		KeyPairGenerator kpg = KeyPairGenerator.getInstance("RSA");
		return kpg.generateKeyPair();
	}
	
	private byte[] sign(byte[] msg) throws NoSuchAlgorithmException, 
					InvalidKeyException, SignatureException {
		Signature sign = Signature.getInstance("SHA1withRSA");
		sign.initSign(privKey);
		sign.update(msg);
		return sign.sign();
	}
	
	private boolean verify (byte[] msg, byte[] signature) throws 
	NoSuchAlgorithmException, InvalidKeyException, SignatureException {
		Signature sign = Signature.getInstance("SHA1withRSA");
		sign.initVerify(pubKey);
		sign.update(msg);
		return sign.verify(signature);
	}
	
	private void printByteArray (byte[] b) {
		for(int i=0; i < b.length; i++) {
			System.out.print((char)b[i]);
		}
		System.out.println("\n");
	}
}
